/*
  % MAP_specification

  % for all i, 0=<i<n => a1[i]>=a2[i]

  forall_gte(I,N,A1,A2) :-
     I=:=N.
  forall_gte(I,N,A1,A2) :-
     I>=0, I+1=<N, I=:=K, K=:=H, I1=:=I+1,
     read((A1,N),K,U), read((A2,N),H,V), U>=V,
     forall_gte(I1,N,A1,A2). 

  incorrect :- forall_gte(I,N,A1,A2), 
  			   gtemaxarray1(N,A1,Max1), 
               gtemaxarray1(N,A2,Max2), 
               N>=1, I=:=0, 
               Max2>=Max1+1.  

  specvars([n,a],[max]). 
*/

int n;
int a[n];
int max;

void main() {

   int i = 1;
   max = a[0];

   while(i < n) {
     if(a[i] > max) {
         max = a[i];
     }
     i++;
   }
}

